{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
{% endblock %}
{% block title %}Scan reports{% endblock %}
{% block content %}
  <style>
    main {
      margin-top: 100px;
    }
  </style>
  <main class="container">
    <h1>All app scan vulnerability reports</h1>

    <div class="mt-4">
      {% for app in apps %}
        <div class="my-2 accordion" id="{{ app.identifier }}-accordion">
          <div class="accordion-item">
            <!-- <h4>{{ app.descriptive_name }}</h4> -->
            <h2 class="accordion-header">
              <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#{{ app.identifier }}-collapse" aria-expanded="false" aria-controls="{{ app.identifier }}-collapse">
                <span class="me-2">{{ app.descriptive_name }}</span>
                {% if app.container_set.count > 0 %}
                  <span class="badge bg-primary" id="{{ app.identifier }}-summary-badge">loading...</span>
                {% else %}
                  <span class="badge bg-secondary">No containers</span>
                {% endif %}
              </button>
            </h2>

            <div id="{{ app.identifier }}-collapse" class="accordion-collapse collapse" data-bs-parent="#{{ app.identifier }}-accordion">
              <div class="report accordion-body" data-app-id="{{ app.identifier }}">

              <!-- Scan report content -->
                {% if app.container_set.count > 0 %}
              <!-- Loading spinner -->
                  <div class="loading-spinner d-flex flex-row align-items-center gap-2 ms-2">
                    <div class="spinner-border text-primary" role="status">
                      <span class="visually-hidden">Loading...</span>
                    </div>
                    <span class="text-primary">Loading report...</span>
                  </div>

                  <ul class="content d-none" data-scan-url="{% url 'scan_containers_app' identifier=app.identifier %}">
                    {% for container in app.container_set.all %}
                      <li id="{{ app.identifier }}-{{ container.id }}" data-scan-report-url="{% url 'scan_report_container' identifier=app.identifier container_id=container.id %}">
                        <span class="me-1">{{ container }}:</span>

                  <!-- Scan error text -->
                        <span class="failed-text text-danger d-none">
                          <span>Failed to scan for container's vulnerabilities</span>
                        </span>
                      </li>
                    {% endfor %}
                  </ul>
                {% else %}
                  <p class="text-secondary">No containers found</p>
                {% endif %}
              </div>
            </div>
          </div>
        </div>
      {% endfor %}
    </div>
  </main>

  <script>
    // Populate scan report contents
    $('.content').each(function() {
      const contentUl = $(this);
      const reportDiv = $(this).closest('.report');
      const scanUrl = $(this).data('scan-url');
      const appId = reportDiv.data('app-id');
      const appSummaryBadge = $(`#${appId}-summary-badge`);

      const severityLevels = {
        "Critical": [4, "bg-red-700 text-white"],
        "Unknown": [3, "bg-red-500 text-white"],
        "High": [3, "bg-red-500 text-white"],
        "Medium": [2, "bg-orange-400 text-black"],
        "Low": [1, "bg-yellow-400 text-black"],
      };

      // Send an AJAX request to scan containers
      $.ajax({
        type: 'GET',
        url: scanUrl,
        success: function(response) {
          console.log(response);
          if (response.status === 200) {
            const appScanReport = {
              "Critical": 0,
              "Unknown": 0,
              "High": 0,
              "Medium": 0,
              "Low": 0,
            };

            // App is considered to be scanned successfully if at least 1 container is scanned successfully
            let appScannedSuccessfully = false;
            // Display number of each vulnerability level for each container
            Object.entries(response.report).forEach(([containerId, vulnerabilities]) => {
              const containerLi = $(`#${appId}-${containerId}`);

              const containerScanReport = {
                "Critical": 0,
                "Unknown": 0,
                "High": 0,
                "Medium": 0,
                "Low": 0,
              }

              if ("error" in vulnerabilities) {
                containerLi.find('.failed-text').removeClass('d-none');
                contentUl.removeClass('d-none');
                reportDiv.find('.loading-spinner').addClass('d-none');
                return;
              }

              appScannedSuccessfully = true;

              // No vulnerabilities found
              if (vulnerabilities.length === 0) {
                containerLi.append('<span class="text-success">No vulnerabilities found</span>');
                contentUl.removeClass('d-none');
                reportDiv.find('.loading-spinner').addClass('d-none');
                return;
              }

              // Display number of vulnerabilities for each level
              for (let i = 0; i < vulnerabilities.length; i++) {
                const vulnerability = vulnerabilities[i];
                containerScanReport[vulnerability.severity] += 1;
                appScanReport[vulnerability.severity] += 1;
              }

              // Display number of vulnerabilities for each level
              containerLiContent = [];
              Object.entries(containerScanReport).forEach(([level, count]) => {
                if (count > 0) {
                  containerLiContent.push(`<span class="badge ${severityLevels[level][1]} me-1">${count} ${level}</span>`);
                }
              });
              const scanReportUrl = containerLi.data('scan-report-url');
              containerLi.append(
                `${containerLiContent.join('')}.
                More <a href="${scanReportUrl}">details</a>.`
              );
            });

            // Display "Failed" badge for app
            // if app is not scanned successfully
            if (!appScannedSuccessfully) {
              appSummaryBadge.text('Failed');
              appSummaryBadge.removeClass().addClass('badge text-bg-danger');
            } else {
              // Get the highest severity level for app
              let highestSeverityLevel = "Low";
              Object.entries(appScanReport).forEach(([level, count]) => {
                if (count > 0 && severityLevels[level][0] > severityLevels[highestSeverityLevel][0]) {
                  highestSeverityLevel = level;
                }
              });

              // Display "No vulnerabilities" badge for app
              if (highestSeverityLevel === "Low" && appScanReport[highestSeverityLevel] === 0) {
                appSummaryBadge.text('No vulnerabilities');
                appSummaryBadge.removeClass().addClass('badge text-bg-success');
              }
              // Display the highest severity level and the total number of vulnerabilities at that level for app
              else {
                appSummaryBadge.text(`${appScanReport[highestSeverityLevel]} ${highestSeverityLevel}`);
                appSummaryBadge.removeClass().addClass(`badge ${severityLevels[highestSeverityLevel][1]}`);
              }
            }

            contentUl.removeClass('d-none');
            reportDiv.find('.loading-spinner').addClass('d-none');
          } else {

          }
        },
        error: function(response) {
          console.log(response);

          // Display "Failed" badge for app
          // if app is not scanned successfully
          appSummaryBadge.text('Failed');
          appSummaryBadge.removeClass().addClass('badge text-bg-danger');
          reportDiv.find('.loading-spinner').addClass('d-none');

          reportDiv.append('<p class="text-danger">Failed to scan for app\'s vulnerabilities</p>');
        }
      });

    })
  </script>
{% endblock %}
